//
//  NetWorkApi.swift
//  naiyoup
//
//  Created by C Auto on 2021/6/2.
//

import HandyJSON
class NetworkApi{
    static let shared = NetworkApi()
    
    private init () {
        
    }
}


extension NetworkApi{
    
    
    
    //登录
    func login(username:String,password:String,success: @escaping Success<LoginModel?>,
               failure: @escaping Failure){
        let url  = "/api/client/v2/login"
        NetWorkTools.getNormalRequestWith(url: url, param: ["email":username,"password":password], networkType: .normalRequest,method:.post) { response in
           
            let data = JSONDeserializer<LoginModel>.deserializeFrom(dict: response as? Dictionary)
            success(data ?? nil)
           
        } failure: { error   in
            failure(error)
        }
    }
    
    //注册
    func reg(usernik:String,username:String,password:String,success: @escaping Success<LoginModel?>,
               failure: @escaping Failure){
        let url  = "/api/client/v2/register"
        NetWorkTools.getNormalRequestWith(url: url, param: ["username":usernik,"email":username,"password":password], networkType: .normalRequest,method:.post) { response in
           
            let data = JSONDeserializer<LoginModel>.deserializeFrom(dict: response as? Dictionary)
            success(data ?? nil)
           
        } failure: { error   in
            failure(error)
        }
    }
    
    //获取节点
    func GetNode(success:@escaping Success<[NodelModel]>,failure: @escaping Failure) {
        
        let url = "/api/client/v2/nodes"
        
        NetWorkTools.getNormalRequestWith(url: url, param: [:], networkType:.normalRequest,method: .get) { response in
            var nolist = [NodelModel]()
            
            if let data = [NodelModel].deserialize(from: response as? Array){
                data.forEach { d in
                    if let v = d{
                        nolist.append(v)
                    }
                }
            }
            success(nolist)

        } failure: { error in
            failure(error)
        }

    }
    
    
    //用户用户信息
    func GetProfile(success:@escaping Success<UserModel?> ,failure: @escaping Failure) {
        
        let url = "/api/client/v2/iosprofile"
        
        NetWorkTools.getNormalRequestWith(url: url, param: ["zfversion":"1.0.5"], networkType:.normalRequest,method: .get) { response in
            let data = JSONDeserializer<UserModel>.deserializeFrom(dict: response as? Dictionary)
            success(data ?? nil)

        } failure: { error in
            failure(error)
        }

    }
    
    //验证并获取 节点
    func Auth(success:@escaping Success<NodelModel?> ,failure: @escaping Failure){
        let url = "/api/client/v2/authUser"
        
        NetWorkTools.getNormalRequestWith(url: url, param: [:], networkType:.normalRequest,method: .get) { response in
            let data = JSONDeserializer<NodelModel>.deserializeFrom(dict: response as? Dictionary)
            success(data ?? nil)

        } failure: { error in
            failure(error)
        }
    }
    
}
