//
//  LazyView.swift
//  naiyoup
//
//  Created by C Auto on 2021/6/4.
//

 
import SwiftUI

public struct LazyView<Content: View>: View {
    private let build: () -> Content
    public init(_ build: @autoclosure @escaping () -> Content) {
        self.build = build
    }
    public var body: Content {
        build()
    }
}
 
