//
//  NodeView.swift
//  naiyoup
//
//  Created by C Auto on 2021/6/4.
//

import SwiftUI
import SwiftUIX
import SwiftyPing
import Combine


class RowData: ObservableObject {
    //var didChange = PassthroughSubject<Void, Never>()

    @Published  var value: String = ""
    @Published  var valueColor: String = ""
    //@Published var isPing = false

    init() {
       //update()
    }

    func update(hosts : Int) {
        log.debug(hosts)
        
        if(hosts <= 49 && hosts >= 1){
            self.value = "流畅"
            self.valueColor = "#00FF00"
        } else if(hosts >= 50 || hosts >= 100){
            self.value = "繁忙"
            self.valueColor = "#FF0000"
        } else if(hosts <= 0){
            self.value = "故障"
            self.valueColor = "#696969"
        }
       
//        let once = try? SwiftyPing(host: hosts, configuration: PingConfiguration(interval: 0.5, with: 5), queue: DispatchQueue.global())
//        once?.observer = { (response) in
//            //let duration = response.duration
//            DispatchQueue.main.async {
//                let ms = Int(response.duration * 1000)
//                self.value = "\(ms) ms"
//                log.debug(self.value)
//                //self.isPing = false
//            }
//
//        }
//        once?.targetCount = 1
//        try? once?.startPinging()
        //self.isPing = true
    }
}

struct PingView: View {
    var name: Int? = 0
    @ObservedObject var loader: RowData

    init(name: Int?, loader: RowData) {
        self.name = name
        self.loader = loader
    }

    var body: some View {
        HStack {
            Text(self.loader.value)
                .foregroundColor(Color.init(hex: self.loader.valueColor))
                .padding()
        }
        .onAppear {
            
            loader.update(hosts: self.name ?? 0)
        }
    }
}

 

struct NodelCell: View {
    
    var name = ""
    
    var host = 0
    
    var body: some View {
        HStack {
            Text(name)
                  .padding()
            Spacer()
              //1-30 流畅 31-100 繁忙 0 故障                          // Ping once
            PingView(name: host , loader: RowData())
        }
        .contentShape(Rectangle())
        .onAppear {
          
        }
    }
}

struct ListRemoveSeparator: ViewModifier {
    func body(content: Content) -> some View {
        content
            .onAppear(perform: {
                UITableView.appearance().tableFooterView = UIView()
                UITableView.appearance().separatorStyle = .none
            })
            .onDisappear(perform: {
                UITableView.appearance().tableFooterView = nil
                UITableView.appearance().separatorStyle = .singleLine
            })
    }
}

struct NodeView: View {
    
    // 追加代码1：声明属性presentationMode
    @Environment(\.presentationMode) var presentationMode: Binding<PresentationMode>
    
    
    @Binding var hosts : String
    //@EnvironmentObject var nodelViewModel : NodelViewModel
    @ObservedObject var nodelViewModel = NodelViewModel.nodel
    @ObservedObject var rowdata = RowData()
    //@Binding var nodelModel : NodelModel
    @State var ping_msg = "点我检测延迟"
    var screenSize: CGRect = UIScreen.main.bounds
    var itmesize = 250
    var minimumInteritemSpacing : CGFloat = 5.0
    var itmesCount : CGFloat = 2.0
    var cellWidth : CGFloat {
        (screenSize.width / itmesCount) - (minimumInteritemSpacing * 2) - 1
    }
  
 
    //itemCount = (CollectionView.width - sectionInset.left - sectionInset.right + minimumInteritemSpacing) / (itemSize + minimumInteritemSpacing)
    
    var body: some View {
        ZStack {
            
            if self.nodelViewModel.loading == true
            {
                ActivityIndicator(isAnimating: self.nodelViewModel.loading)
                    .configure { $0.color = .blue}
                    .padding()

            } else if self.nodelViewModel.isAlt == true {

                VStack{
                    Text("\(self.nodelViewModel.errmsg)")
                        .foregroundColor(Color.black)

                    Text("点击重试")
                        .foregroundColor(Color.black)
                        .onTapGesture {
                            self.nodelViewModel.GetNode()
                        }
                }



            } else {
                Color("NodeItem")
                List{
                    ForEach(0..<self.nodelViewModel.nodeList.count,id:\.self){ index in

                        NodelCell(name: self.nodelViewModel.nodeList[index].name  ?? "", host: self.nodelViewModel.nodeList[index].online_users)
                            .frame(height: 60)

                            .onTapGesture {

                                self.nodelViewModel.nodeModel = self.nodelViewModel.nodeList[index]
                                self.hosts = self.nodelViewModel.nodeModel?.name ?? "智能选线"
                                //self.isPop = false
                                self.presentationMode.wrappedValue.dismiss()
                            }
                            .background(Color.init(hex: "#FFFFFF"))
                            
                    }
                }
            }
            
    
        }
        .onAppear {
            let controller = UIApplication.shared.windows[0].rootViewController as? MyHontingController
            controller?.statusBarStyle = .lightContent
            nodelViewModel.GetNode()
           
        }
        .navigationBarTitle(Text("节点"), displayMode: .inline)
        //.navigationBarHidden(true)
        
    }
    
    
}
 
