//
//  LoginViewModel.swift
//  naiyoup
//
//  Created by C Auto on 2021/5/29.
//

import Foundation
import SwiftyUserDefaults
enum UserDefaultKey: String {
    case login = "LoginDefaultKey"
}
class LoginViewModel: ObservableObject {
    @Published var islogin  : Bool = false

    @Published var loading : Bool = false
    @Published var isActive : Bool = false
 
//
    @Published var loginModel : LoginModel? = nil
    @Published var errmsg : String = ""
    @Published var isAlt : Bool = false
    
    //@Published var isReg : Bool = false
    
    @Published var usernick : String  = ""
    @Published var username : String  = ""
    @Published var password : String  = ""
    
    static let user = LoginViewModel()
    
    func getLoginFlag() -> Bool{
        if Defaults[\.loginModel] != nil {
            let b = UserDefaults.standard.bool(forKey: UserDefaultKey.login.rawValue)
            return b
        }
        return false
    }
    
    func setLoginFlag(flag: Bool){
        UserDefaults.standard.set(flag, forKey: UserDefaultKey.login.rawValue)
        if(UserDefaults.standard.synchronize()){
            print("\(flag ? "true: 登录成功跳到主界面": "false: 登出成功跳到登录界面")")
            self.islogin = flag
        }else{
            print("存储失败")
            self.islogin = !flag
        }
    }
    
    func Reg() {
        self.loading = true
        NetworkApi.shared.reg(usernik: usernick , username: username, password:password ) { loginModel in
            self.isAlt  = false
            self.loading  = false
            let username_t = self.username
            Defaults[\.Islogin]    =  self.islogin
            Defaults[\.username]   =  username_t
            Defaults[\.passrowd]   =  self.password
            
            if let model = loginModel{
                //保存对象到序列
                Defaults[\.loginModel]  = model.toJSONString() ?? ""
                //保存给变量
                self.loginModel = model
                
                self.setLoginFlag(flag: true)
                
            } else {
               self.errmsg = "解析错误,重新登录"
            }
        } failure: { err in
            self.loading  = false
//            self.HidLoading()
//            self.LoginHidLoading()
            self.isAlt = true
           self.SetError(err: err)
        }

    
    }
    
    func login() {
        //请求登陆
        //self.ShowLoading()
        self.loading = true
        NetworkApi.shared.login(username: username, password: password) { loginModel in
//            self.HidLoading()
//            self.LoginLoading()
            self.isAlt  = false
            self.loading  = false
            let username_t = self.username
            Defaults[\.Islogin]    =  self.islogin
            Defaults[\.username]   =  username_t
            Defaults[\.passrowd]   =  self.password
            
            
            if let model = loginModel{
                //保存对象到序列
                Defaults[\.loginModel]  = model.toJSONString() ?? ""
                //保存给变量
                self.loginModel = model
                
                self.setLoginFlag(flag: true)
                
            } else {
               self.errmsg = "解析错误,重新登录"
            }

        } failure: { err in
            self.loading  = false
//            self.HidLoading()
//            self.LoginHidLoading()
            self.isAlt = true
           self.SetError(err: err)
        }

        
    }
    
    
    
    private func SetViewError(msg:String) {
        self.errmsg = msg
    }
    
    
    func SetError(err: ErrorCode) {
    
        switch err{
        case .sysError(let ret):
           // self.errmsg = ret
            self.SetViewError(msg: ret)
            break;
        case .invalidResponse(let ret):
            //self.errmsg = ret
            self.SetViewError(msg: ret)
            
            break
             
        case .networkUnavailable(let msg, let code):
            //self.errmsg = "\(String(describing: msg))\(String(describing: code))"
            
            self.SetViewError(msg: "\(String(describing: msg))\(String(describing: code))")
            break
    
        case .needRetrier(_, _, _):
            break
        case .uploadError(_, _, _, _, _):
            break
      
        case .tokenError(let msg):
            self.errmsg = msg
           // self.islogin = false
            Defaults[\.loginModel] = ""
        }
        
        
    }
    
}
